/* sortlines.c : tri du stdin sur stdout en un seul fichier source */
#include <stdio.h>
#include <stdlib.h>

int comparelines(char **a, char **b)
{int i=0;
 while((*a)[i]!='\0' && (*b)[i]!='\0' && (*a)[i] == (*b)[i])
   {i++;};
 if ((*a)[i]=='\0' && (*b)[i]=='\0') return 0;
 if ((*a)[i]=='\0') return 1;
 if ((*b)[i]=='\0') return -1;
 return((*a)[i]-(*b)[i]);
}

/* Fonction de lecture d'une ligne avec allocation dynamique */

int readline(FILE *fp,char **res)
{int taille_cour,curseur;
 char *tampon,c;
 
 curseur=0;
 taille_cour=16;
 
 /* Allocation initiale de taille_cour cases pour le tampon */
 tampon=(char *)malloc(sizeof(char)*taille_cour);
 
 while ((c=getc(fp))!=EOF && c!='\n')
   {tampon[curseur++]=c;
   if (curseur==taille_cour) 
     {taille_cour*=2; /* doubler le tampon: Ne Pas Oublier Sizeof! */
     realloc(tampon,taille_cour*sizeof(char)); };
   };
 tampon[curseur]='\0';
 *res=tampon;
 if (c==EOF) {return 0;};
 return 1;
}
 
/* Fonction de lecture d'un fichier avec allocation dynamique */
 
int readfile(FILE *pf, char ***lignes, int *nlines)
{char *buf,**tmp;
 int taille_cour=100,i=0;
 
 /* commencons la lecture apres avoir alloue la memoire */
 tmp=(char **)malloc(taille_cour*sizeof(char *));
 
 while (readline(pf,&buf)!=0)
   { tmp[i++]=buf;
   if (i==taille_cour) /* il faut doubler le tampon */
     {taille_cour*=2;
     realloc(tmp,taille_cour*sizeof(char *));
     };
   };
 tmp[i]=buf;
 (*lignes)=tmp;
 (*nlines)=i;
 return(0);
}
   

main()
{FILE *fp;
 char *fn;
 char **lines;
 char *buf;
 int cursize=100;
 int used=0,i;
 
 readfile(stdin,&lines,&used); /* used contient le nombre de lignes */
 qsort(lines,used-1,sizeof(char *),comparelines);
 while (used-->0) {printf("%s\n",lines[used]);};
 exit(0);
}
